Update an action's permissions
PATCH/v1/actions/:action_identifier/permissions
This route allows you to update the permissions of a self-service action.
To learn more about action RBAC, check out the documentation.
Request
Parameters (JSON)
{
"parameters": [
{
"schema": {
"type": "string",
"minLength": 1
},
"in": "path",
"name": "action_identifier",
"required": true,
"description": "The identifier of the action/automation you want to operate on."
}
]
}Request body schema (JSON)
{
"title": "Body",
"body": {
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"execute": {
"type": "object",
"description": "An object used to define who can execute the action.",
"properties": {
"users": {
"type": "array",
"items": {
"type": "string"
},
"description": "The email addresses of the users who can execute the action."
},
"roles": {
"type": "array",
"items": {
"type": "string"
},
"description": "The roles that can execute the action."
},
"teams": {
"type": "array",
"items": {
"type": "string"
},
"description": "The names of the teams whose members can execute the action."
},
"ownedByTeam": {
"type": "boolean",
"description": "Relevant only for [DAY-2/DELETE actions](https://docs.port.io/workflows/actions-and-automations/create-self-service-experiences/setup-ui-for-action/#basic-details). If `true`, any member of the team that the entity belongs to can execute the action."
},
"policy": {
"type": [
"object",
"null"
],
"properties": {
"queries": {
"type": "object",
"description": "One or more queries to fetch data from your software catalog.",
"minProperties": 1,
"additionalProperties": {
"title": "Entities query",
"type": "object",
"properties": {
"combinator": {
"enum": [
"and",
"or"
],
"description": "The combinator to use for the rules."
},
"rules": {
"type": "array",
"items": {
"anyOf": [
{
"type": "object",
"title": "Date Rule",
"properties": {
"property": {
"title": "Contexted property",
"oneOf": [
{
"type": "string"
},
{
"type": "object",
"title": "User-context field",
"properties": {
"property": {
"type": "string"
},
"context": {
"type": "string",
"enum": [
"user",
"userTeams"
]
}
},
"required": [
"property",
"context"
]
}
]
},
"operator": {
"enum": [
"between",
"notBetween",
"="
]
},
"value": {
"type": "object",
"oneOf": [
{
"type": "object",
"title": "Date Range",
"properties": {
"from": {
"type": "string",
"format": "date-time"
},
"to": {
"type": "string",
"format": "date-time"
}
},
"required": [
"from",
"to"
]
},
{
"type": "object",
"title": "Date Preset",
"properties": {
"preset": {
"type": "string",
"enum": [
"today",
"tomorrow",
"yesterday",
"lastDay",
"lastWeek",
"last2Weeks",
"lastMonth",
"last3Months",
"last6Months",
"last12Months",
"last2Years",
"last3Years",
"nextDay",
"nextWeek",
"next2Weeks",
"nextMonth",
"next3Months",
"next6Months",
"next12Months"
]
}
},
"required": [
"preset"
]
},
{
"type": "object",
"title": "User-context field",
"properties": {
"property": {
"type": "string"
},
"context": {
"type": "string",
"enum": [
"user",
"userTeams"
]
}
},
"required": [
"property",
"context"
]
}
]
}
},
"required": [
"property",
"operator",
"value"
],
"additionalProperties": false
},
{
"type": "object",
"title": "Empty Rule",
"oneOf": [
{
"type": "object",
"title": "Empty Rule",
"properties": {
"operator": {
"enum": [
"isEmpty",
"isNotEmpty"
]
},
"property": {
"type": "string"
}
},
"required": [
"operator",
"property"
],
"additionalProperties": false
}
]
},
{
"type": "object",
"title": "Number Rule",
"properties": {
"property": {
"title": "Contexted property",
"oneOf": [
{
"type": "string"
},
{
"type": "object",
"title": "User-context field",
"properties": {
"property": {
"type": "string"
},
"context": {
"type": "string",
"enum": [
"user",
"userTeams"
]
}
},
"required": [
"property",
"context"
]
}
]
},
"operator": {
"enum": [
">",
">=",
"<",
"<="
]
},
"value": {
"anyOf": [
{
"type": "number",
"title": "number"
},
{
"type": "string",
"format": "date-time",
"title": "date-time"
},
{
"type": "object",
"title": "User-context field",
"properties": {
"property": {
"type": "string"
},
"context": {
"type": "string",
"enum": [
"user",
"userTeams"
]
}
},
"required": [
"property",
"context"
]
}
]
}
},
"required": [
"property",
"operator",
"value"
],
"additionalProperties": false
},
{
"type": "object",
"title": "Expired Rule",
"oneOf": [
{
"type": "object",
"title": "Expired Rule",
"properties": {
"operator": {
"enum": [
"isExpired",
"isNotExpired"
]
},
"property": {
"type": "string"
}
},
"required": [
"operator",
"property"
],
"additionalProperties": false
}
]
},
{
"type": "object",
"title": "String Rule",
"oneOf": [
{
"type": "object",
"title": "String Rule",
"properties": {
"property": {
"title": "Contexted property",
"oneOf": [
{
"type": "string"
},
{
"type": "object",
"title": "User-context field",
"properties": {
"property": {
"type": "string"
},
"context": {
"type": "string",
"enum": [
"user",
"userTeams"
]
}
},
"required": [
"property",
"context"
]
}
]
},
"operator": {
"enum": [
"=",
"!=",
"containsAny",
"contains",
"doesNotContains",
"beginsWith",
"doesNotBeginsWith",
"endsWith",
"doesNotEndsWith",
"in",
"notIn"
]
},
"value": {
"anyOf": [
{
"type": "null",
"title": "null"
},
{
"type": "string",
"title": "string"
},
{
"type": "number",
"title": "number"
},
{
"type": "boolean",
"title": "boolean"
},
{
"type": "string",
"format": "date-time",
"title": "date-time"
},
{
"type": "array",
"items": {
"type": "string"
},
"title": "array"
},
{
"type": "array",
"items": {
"type": "number"
},
"title": "array"
},
{
"type": "array",
"items": {
"type": "boolean"
},
"title": "array"
},
{
"type": "array",
"items": {
"type": "string",
"format": "date-time"
},
"title": "array"
},
{
"type": "object",
"title": "User-context field",
"properties": {
"property": {
"type": "string"
},
"context": {
"type": "string",
"enum": [
"user",
"userTeams"
]
}
},
"required": [
"property",
"context"
]
}
]
}
},
"additionalProperties": false,
"required": [
"property",
"operator",
"value"
]
}
]
},
{
"type": "object",
"title": "Relation Rule",
"properties": {
"operator": {
"enum": [
"relatedTo"
]
},
"blueprint": {
"type": "string"
},
"value": {
"anyOf": [
{
"type": "string",
"title": "string"
},
{
"type": "array",
"items": {
"type": "string"
},
"title": "array"
}
]
},
"direction": {
"enum": [
"upstream",
"downstream"
]
},
"required": {
"type": "boolean"
}
},
"additionalProperties": false,
"required": [
"operator",
"value",
"blueprint"
]
},
{
"type": "object",
"title": "Property schema rule",
"properties": {
"propertySchema": {
"type": "object",
"properties": {
"type": {
"type": "string"
},
"format": {
"type": "string"
},
"items": {
"type": "object",
"properties": {
"type": {
"type": "string"
},
"format": {
"type": "string"
}
},
"required": [
"type"
]
}
},
"required": [
"type"
],
"additionalProperties": false
},
"operator": {
"enum": [
"=",
"!=",
"contains"
]
},
"value": {
"anyOf": [
{
"type": "null",
"title": "null"
},
{
"type": "string",
"title": "string"
},
{
"type": "number",
"title": "number"
},
{
"type": "boolean",
"title": "boolean"
}
]
}
},
"required": [
"operator",
"propertySchema"
],
"additionalProperties": false
},
{
"type": "object",
"title": "matchAny Rule",
"anyOf": [
{
"type": "object",
"title": "Property matchAny rule",
"properties": {
"property": {
"oneOf": [
{
"type": "object",
"title": "Path filter property",
"properties": {
"path": {
"type": "array",
"minItems": 1,
"items": {
"anyOf": [
{
"type": "string",
"title": "Relation identifier"
},
{
"type": "object",
"title": "Relation with max hops",
"properties": {
"relation": {
"type": "string"
},
"maxHops": {
"type": "number",
"minimum": 1,
"maximum": 15
}
}
}
]
}
},
"fromBlueprint": {
"type": "string"
}
},
"required": [
"path"
],
"additionalProperties": false
},
{
"title": "Contexted property",
"oneOf": [
{
"type": "string"
},
{
"type": "object",
"title": "User-context field",
"properties": {
"property": {
"type": "string"
},
"context": {
"type": "string",
"enum": [
"user",
"userTeams"
]
}
},
"required": [
"property",
"context"
]
}
]
}
]
},
"operator": {
"type": "string",
"enum": [
"matchAny"
]
},
"value": {
"anyOf": [
{
"type": "array",
"items": {
"type": "string"
}
},
{
"title": "Contexted property",
"oneOf": [
{
"type": "string"
},
{
"type": "object",
"title": "User-context field",
"properties": {
"property": {
"type": "string"
},
"context": {
"type": "string",
"enum": [
"user",
"userTeams"
]
}
},
"required": [
"property",
"context"
]
}
]
}
]
}
},
"required": [
"property",
"operator",
"value"
],
"additionalProperties": false
}
]
},
{
"allOf": [
"circular(Entities query)",
{
"title": "Nested query"
}
]
}
]
}
}
},
"required": [
"combinator",
"rules"
],
"additionalProperties": false,
"example": {
"combinator": "and",
"rules": [
{
"property": "$blueprint",
"operator": "=",
"value": "service"
},
{
"combinator": "or",
"rules": [
{
"property": "environment",
"operator": "=",
"value": "production"
},
{
"property": "environment",
"operator": "=",
"value": "staging"
}
]
}
]
}
}
},
"conditions": {
"type": "array",
"items": {
"type": "string",
"minLength": 1
},
"minItems": 1,
"description": "`JQ` expressions that run against the provided queries, and resolve to a boolean value (`true` = allowed to execute)."
}
},
"required": [
"queries",
"conditions"
],
"additionalProperties": false,
"description": "An optional custom policy the determines if action execution is allowed.<br/>See instructions and examples [here](https://docs.port.io/workflows/actions-and-automations/create-self-service-experiences/set-self-service-actions-rbac/dynamic-permissions/#configuration)."
}
},
"additionalProperties": false
},
"approve": {
"type": "object",
"description": "An object used to define who can approve the action.",
"properties": {
"users": {
"type": "array",
"items": {
"type": "string"
},
"description": "The email addresses of the users who can approve the action."
},
"roles": {
"type": "array",
"items": {
"type": "string"
},
"description": "The roles that can approve the action."
},
"teams": {
"type": "array",
"items": {
"type": "string"
},
"description": "The names of the teams whose members can approve the action."
},
"policy": {
"type": [
"object",
"null"
],
"properties": {
"queries": {
"type": "object",
"description": "One or more queries to fetch data from your software catalog.",
"minProperties": 1,
"additionalProperties": {
"title": "Entities query",
"type": "object",
"properties": {
"combinator": {
"enum": [
"and",
"or"
],
"description": "The combinator to use for the rules."
},
"rules": {
"type": "array",
"items": {
"anyOf": [
{
"type": "object",
"title": "Date Rule",
"properties": {
"property": {
"title": "Contexted property",
"oneOf": [
{
"type": "string"
},
{
"type": "object",
"title": "User-context field",
"properties": {
"property": {
"type": "string"
},
"context": {
"type": "string",
"enum": [
"user",
"userTeams"
]
}
},
"required": [
"property",
"context"
]
}
]
},
"operator": {
"enum": [
"between",
"notBetween",
"="
]
},
"value": {
"type": "object",
"oneOf": [
{
"type": "object",
"title": "Date Range",
"properties": {
"from": {
"type": "string",
"format": "date-time"
},
"to": {
"type": "string",
"format": "date-time"
}
},
"required": [
"from",
"to"
]
},
{
"type": "object",
"title": "Date Preset",
"properties": {
"preset": {
"type": "string",
"enum": [
"today",
"tomorrow",
"yesterday",
"lastDay",
"lastWeek",
"last2Weeks",
"lastMonth",
"last3Months",
"last6Months",
"last12Months",
"last2Years",
"last3Years",
"nextDay",
"nextWeek",
"next2Weeks",
"nextMonth",
"next3Months",
"next6Months",
"next12Months"
]
}
},
"required": [
"preset"
]
},
{
"type": "object",
"title": "User-context field",
"properties": {
"property": {
"type": "string"
},
"context": {
"type": "string",
"enum": [
"user",
"userTeams"
]
}
},
"required": [
"property",
"context"
]
}
]
}
},
"required": [
"property",
"operator",
"value"
],
"additionalProperties": false
},
{
"type": "object",
"title": "Empty Rule",
"oneOf": [
{
"type": "object",
"title": "Empty Rule",
"properties": {
"operator": {
"enum": [
"isEmpty",
"isNotEmpty"
]
},
"property": {
"type": "string"
}
},
"required": [
"operator",
"property"
],
"additionalProperties": false
}
]
},
{
"type": "object",
"title": "Number Rule",
"properties": {
"property": {
"title": "Contexted property",
"oneOf": [
{
"type": "string"
},
{
"type": "object",
"title": "User-context field",
"properties": {
"property": {
"type": "string"
},
"context": {
"type": "string",
"enum": [
"user",
"userTeams"
]
}
},
"required": [
"property",
"context"
]
}
]
},
"operator": {
"enum": [
">",
">=",
"<",
"<="
]
},
"value": {
"anyOf": [
{
"type": "number",
"title": "number"
},
{
"type": "string",
"format": "date-time",
"title": "date-time"
},
{
"type": "object",
"title": "User-context field",
"properties": {
"property": {
"type": "string"
},
"context": {
"type": "string",
"enum": [
"user",
"userTeams"
]
}
},
"required": [
"property",
"context"
]
}
]
}
},
"required": [
"property",
"operator",
"value"
],
"additionalProperties": false
},
{
"type": "object",
"title": "Expired Rule",
"oneOf": [
{
"type": "object",
"title": "Expired Rule",
"properties": {
"operator": {
"enum": [
"isExpired",
"isNotExpired"
]
},
"property": {
"type": "string"
}
},
"required": [
"operator",
"property"
],
"additionalProperties": false
}
]
},
{
"type": "object",
"title": "String Rule",
"oneOf": [
{
"type": "object",
"title": "String Rule",
"properties": {
"property": {
"title": "Contexted property",
"oneOf": [
{
"type": "string"
},
{
"type": "object",
"title": "User-context field",
"properties": {
"property": {
"type": "string"
},
"context": {
"type": "string",
"enum": [
"user",
"userTeams"
]
}
},
"required": [
"property",
"context"
]
}
]
},
"operator": {
"enum": [
"=",
"!=",
"containsAny",
"contains",
"doesNotContains",
"beginsWith",
"doesNotBeginsWith",
"endsWith",
"doesNotEndsWith",
"in",
"notIn"
]
},
"value": {
"anyOf": [
{
"type": "null",
"title": "null"
},
{
"type": "string",
"title": "string"
},
{
"type": "number",
"title": "number"
},
{
"type": "boolean",
"title": "boolean"
},
{
"type": "string",
"format": "date-time",
"title": "date-time"
},
{
"type": "array",
"items": {
"type": "string"
},
"title": "array"
},
{
"type": "array",
"items": {
"type": "number"
},
"title": "array"
},
{
"type": "array",
"items": {
"type": "boolean"
},
"title": "array"
},
{
"type": "array",
"items": {
"type": "string",
"format": "date-time"
},
"title": "array"
},
{
"type": "object",
"title": "User-context field",
"properties": {
"property": {
"type": "string"
},
"context": {
"type": "string",
"enum": [
"user",
"userTeams"
]
}
},
"required": [
"property",
"context"
]
}
]
}
},
"additionalProperties": false,
"required": [
"property",
"operator",
"value"
]
}
]
},
{
"type": "object",
"title": "Relation Rule",
"properties": {
"operator": {
"enum": [
"relatedTo"
]
},
"blueprint": {
"type": "string"
},
"value": {
"anyOf": [
{
"type": "string",
"title": "string"
},
{
"type": "array",
"items": {
"type": "string"
},
"title": "array"
}
]
},
"direction": {
"enum": [
"upstream",
"downstream"
]
},
"required": {
"type": "boolean"
}
},
"additionalProperties": false,
"required": [
"operator",
"value",
"blueprint"
]
},
{
"type": "object",
"title": "Property schema rule",
"properties": {
"propertySchema": {
"type": "object",
"properties": {
"type": {
"type": "string"
},
"format": {
"type": "string"
},
"items": {
"type": "object",
"properties": {
"type": {
"type": "string"
},
"format": {
"type": "string"
}
},
"required": [
"type"
]
}
},
"required": [
"type"
],
"additionalProperties": false
},
"operator": {
"enum": [
"=",
"!=",
"contains"
]
},
"value": {
"anyOf": [
{
"type": "null",
"title": "null"
},
{
"type": "string",
"title": "string"
},
{
"type": "number",
"title": "number"
},
{
"type": "boolean",
"title": "boolean"
}
]
}
},
"required": [
"operator",
"propertySchema"
],
"additionalProperties": false
},
{
"type": "object",
"title": "matchAny Rule",
"anyOf": [
{
"type": "object",
"title": "Property matchAny rule",
"properties": {
"property": {
"oneOf": [
{
"type": "object",
"title": "Path filter property",
"properties": {
"path": {
"type": "array",
"minItems": 1,
"items": {
"anyOf": [
{
"type": "string",
"title": "Relation identifier"
},
{
"type": "object",
"title": "Relation with max hops",
"properties": {
"relation": {
"type": "string"
},
"maxHops": {
"type": "number",
"minimum": 1,
"maximum": 15
}
}
}
]
}
},
"fromBlueprint": {
"type": "string"
}
},
"required": [
"path"
],
"additionalProperties": false
},
{
"title": "Contexted property",
"oneOf": [
{
"type": "string"
},
{
"type": "object",
"title": "User-context field",
"properties": {
"property": {
"type": "string"
},
"context": {
"type": "string",
"enum": [
"user",
"userTeams"
]
}
},
"required": [
"property",
"context"
]
}
]
}
]
},
"operator": {
"type": "string",
"enum": [
"matchAny"
]
},
"value": {
"anyOf": [
{
"type": "array",
"items": {
"type": "string"
}
},
{
"title": "Contexted property",
"oneOf": [
{
"type": "string"
},
{
"type": "object",
"title": "User-context field",
"properties": {
"property": {
"type": "string"
},
"context": {
"type": "string",
"enum": [
"user",
"userTeams"
]
}
},
"required": [
"property",
"context"
]
}
]
}
]
}
},
"required": [
"property",
"operator",
"value"
],
"additionalProperties": false
}
]
},
{
"allOf": [
"circular(Entities query)",
{
"title": "Nested query"
}
]
}
]
}
}
},
"required": [
"combinator",
"rules"
],
"additionalProperties": false,
"example": {
"combinator": "and",
"rules": [
{
"property": "$blueprint",
"operator": "=",
"value": "service"
},
{
"combinator": "or",
"rules": [
{
"property": "environment",
"operator": "=",
"value": "production"
},
{
"property": "environment",
"operator": "=",
"value": "staging"
}
]
}
]
}
}
},
"conditions": {
"type": "array",
"items": {
"type": "string",
"minLength": 1
},
"minItems": 1,
"description": "`JQ` expressions that run against the provided queries, and resolve to a boolean value (`true` = allowed to execute)."
}
},
"required": [
"queries",
"conditions"
],
"additionalProperties": false,
"description": "An optional custom policy the determines who can approve the action.<br/>See instructions and examples [here](https://docs.port.io/workflows/actions-and-automations/create-self-service-experiences/set-self-service-actions-rbac/dynamic-permissions/#configuration)."
}
},
"additionalProperties": false
}
},
"additionalProperties": false
}
}
}
}
}Responses
- 401
- 404
- 413
- 422
Default Response
A resource with the provided identifier was not found
Request body is too large (limit is 1MiB)
The json provided does not match the route's schema
Responses (JSON)
{
"responses": {
"401": {
"description": "Default Response",
"content": {
"application/json": {
"schema": {
"properties": {
"ok": {
"const": false
},
"error": {
"type": "string"
},
"message": {
"type": "string"
}
},
"required": [
"ok",
"error"
],
"additionalProperties": false
}
}
}
},
"404": {
"description": "A resource with the provided identifier was not found",
"content": {
"application/json": {
"schema": {
"properties": {
"ok": {
"const": false
},
"error": {
"type": "string"
},
"message": {
"type": "string"
}
},
"required": [
"ok",
"error",
"message"
],
"additionalProperties": false,
"description": "A resource with the provided identifier was not found"
}
}
}
},
"413": {
"description": "Request body is too large (limit is 1MiB)",
"content": {
"application/json": {
"schema": {
"properties": {
"ok": {
"const": false
},
"error": {
"type": "string"
},
"message": {
"type": "string"
}
},
"required": [
"ok",
"error"
],
"additionalProperties": false,
"description": "Request body is too large (limit is 1MiB)"
}
}
}
},
"422": {
"description": "The json provided does not match the route's schema",
"content": {
"application/json": {
"schema": {
"properties": {
"ok": {
"const": false
},
"error": {
"type": "string"
},
"message": {
"type": "string"
}
},
"required": [
"ok",
"error",
"message"
],
"additionalProperties": false,
"description": "The json provided does not match the route's schema"
}
}
}
}
}
}